select
    an.numero
    , (select descricao from grupoanimal where cdgrupoanimal =
        (select grupo
        from sp_grupoanimalespecifico (
            current_date,
            (select first 1 cdtipogrupoanimal
                from tipogrupoanimal
                where upper(descricao) like '%LOTE%'),
            apli.cdanimal))) as Lote
    , (select count(*) from lactacao where cdanimal = apli.cdanimal and dtinicio < apli.dtaplicacaoproduto) as Lactacao
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto + 6)
            and cdanimal = apli.cdanimal) as Producao_D_6
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto + 5)
            and cdanimal = apli.cdanimal) as Producao_D_5
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto + 4)
            and cdanimal = apli.cdanimal) as Producao_D_4
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto + 3)
            and cdanimal = apli.cdanimal) as Producao_D_3
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto + 2)
            and cdanimal = apli.cdanimal) as Producao_D_2
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto + 1)
            and cdanimal = apli.cdanimal) as Producao_D_1
    , (select pesototal
        from leite
        where dtleite = (apli.dtaplicacaoproduto)
            and cdanimal = apli.cdanimal) as Producao_D_0
    , (apli.dtaplicacaoproduto - lac.dtinicio) as DEL
    , (select first 1 data
        from reproducao
        where cdanimal = apli.cdanimal
            and cdtiporeproducao = 7
            and data < apli.dtaplicacaoproduto
        order by data desc) as Ultimo_Parto
    , (select first 1 data
        from reproducao
        where cdanimal = apli.cdanimal
            and cdtiporeproducao in (1,2,3)
            and data < current_date
        order by data desc) as Ultima_Tentativa
    , (case
        when (select creprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 1 then 'Coberta'
        when (select creprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 2 then 'Implantada'
        when (select creprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 3 then 'Gestante'
        when (select creprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 4 then 'Vazia' || ': ' ||
            (case
                when (select sreprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 1 then 'Apta'
                when (select sreprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 2 then 'Atrasada'
                when (select sreprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) = 3 then 'PEV'
                else (select sreprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal))  end)
        else (select creprodutiva from sp_categoriaanimal (current_date, 'cdanimal = ' || apli.cdanimal)) end) as Categoria
    , apli.dtaplicacaoproduto
    , prod.nome as Medicamento
from animal an
    join aplicacaoproduto apli on apli.cdanimal = an.cdanimal
    join produto prod on prod.cdproduto = apli.cdproduto
    join lactacao lac on lac.cdanimal = apli.cdanimal
        and lac.dtinicio < apli.dtaplicacaoproduto
        and ((lac.dtfim > apli.dtaplicacaoproduto) or (lac.dtfim is null))
where
---ALTERAR O PERODO DE APLICAO DE MEDICAMENTOS AQUI, CONFORME DESEJADO - MANTER O FORMATO DA DATA 'AAAA-MM-DD'.
    apli.dtaplicacaoproduto between '2015-01-01' and '2016-01-15'
    and ((upper(prod.nome) like '%BOOSTIN%')or (upper(prod.nome) like '%LACTO%'))
order by an.numordenado, apli.dtaplicacaoproduto